#include <iostream>
#include <vector>
#include "universitystudent.hpp"
#include "universityteacher.hpp"
#include "course.hpp"
using namespace std;

int main()
{
    UniversityTeacher groberto("Giachetta Roberto");
    Course course1("Programozás 1", &groberto, 4);
    Course course2("Programozás 2", &groberto, 4);

    UniversityStudent s1("Benő Jenő");
    UniversityStudent s2("Faragatlan Ferenc");
    UniversityStudent s3("Tojás Tóbiás");

    s1.newCourse(&course1);
    s2.newCourse(&course1);
    s3.newCourse(&course2);

    s1.newCourse(&course1); // másodszor is megpróbálja felvenni a kurzust, siekrtelenül
    cout << course1.name() << ", létszám: " << course1.currentHeadCount() << endl;
    cout << s1.name() << ", kurzusok száma: " << s1.numberOfCourses() << endl;

    vector<UniversityCitizen*> citizens;
    citizens.push_back(&groberto); // polimorfizmust használunk
    citizens.push_back(&s1);
    citizens.push_back(&s2);
    citizens.push_back(&s3);

    cout << "Az egyetem polgárai: " << endl;
    for (int i = 0; i < citizens.size(); i++)
    {
        cout << citizens[i]->name() << ", NEPTUN: " << citizens[i]->neptunCode() << endl;
    }

    return 0;
}
