#include "universitycitizen.hpp"
#include <cstdlib>
#include <ctime>
using namespace std;

UniversityCitizen::UniversityCitizen(const string& n) : _name(n)
{
    _neptunCode = generateCode();
    _neptunPassword = generatePassword();
}

string UniversityCitizen::name() const
{
    return _name;
}

string UniversityCitizen::neptunCode() const
{
    return _neptunCode;
}

const vector<Course*>& UniversityCitizen::courses() const
{
    return _courses;
}

int UniversityCitizen::numberOfCourses() const
{
    return _courses.size();
}

void UniversityCitizen::newCourse(Course* c)
{
    for (unsigned int i = 0; i < _courses.size(); i++)
        if (_courses[i] == c) // ha mr oktatoja a kurzust
            return; // akkor nem csinlunk semmit
    _courses.push_back(c);
}

string UniversityCitizen::generateCode()
{
    srand(time(0));
    string code = "";
    for (int i = 0; i < 6; i++)
        code += rand() % 36 + 65;
    return code;
}

string UniversityCitizen::generatePassword()
{
    srand(time(0));
    string pw = "";
    for (int i = 0; i < 8; i++)
        pw += rand() % 36 + 97;
    return pw;
}
